SystemOrganization addCategory: #'GBT-DSL_GC_Program'!

Object subclass: #GCContexts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Program'!

!GCContexts class methodsFor: 'process contexts' stamp: 'hk 1/27/2018 17:01'!
gcActivitiesContext  
	^GbtPrimeListSC  struct: 'GCActivitiesContext' define: { 
		{#displayAs: . 'Activities' }.
		{#noPolicyGetter: . #alphaSmallID}.
		{#uiSpec:icon: . #GbtListUI . #activity16}.
		{#templates: . GCBizProcess bizActivities }.
		{#subcontext: . self gcActivityContext  } .
	}
		
! !

!GCContexts class methodsFor: 'process contexts' stamp: 'hk 1/27/2018 17:01'!
gcActivityContext  
	^GbtPlainSC  struct: 'GCActivityContext' define: { 
		{#displayAs: . 'Activity' }.
		{#uiSpec:icon: . #GbtItemUI . #activity16}.
	}
		
! !

!GCContexts class methodsFor: 'process contexts' stamp: 'hk 1/27/2018 17:01'!
gcBizProcessContext  
	
	^GbtPlainSC struct: 'GCBizProcessContext'  define: { 
		{ #displayAs:  .'Biz Process'  } .
		{ #uiSpec:icon: . #GbtItemWithTabsUI . #bizProcesses} .
		{ #blackboardAspect:on: . GCContexts gcServiceDataContext . #bizProcessServiceData } .
		{ #aspect:on: . GCContexts gcCustomerContext . #bizCustomer } .
		{ #aspect:on: . GCContexts gcRequestContext . #bizRequest } .
		{ #aspect:on: . GCContexts gcOfferContext . #bizOffer } .
		{ #aspect:on: . GCContexts gcOrderContext . #bizOrder } .
		{ #aspect:on: . GCContexts gcActivitiesContext . #bizActivities } .

		{#menu:items: . #BizNet . #(#'Confirm Request' #'Send Offer' #'Confirm Order') }.
		{#menu:items: . #ServiceData . #(#'From Request' #'From Offer' #'From Order') }.
		{#behavior:actions: . #'Confirm Request' . #(COMPOSE GCBizNetConfirmRequest SENDTO #(bizCustomer company))}. 
		{#behavior:actions: . #'Confirm Order' . #(COMPOSE GCBizNetConfirmOrder SENDTO #(bizCustomer company))}.
		{#behavior:actions: . #'Send Offer' . #(COMPOSE GCBizNetOffer SENDTO #(bizCustomer company))}.

		{#behavior:actions: . #'From Request' . #(
			READSLOT #(bizRequestServiceData v1)
			WRITESLOT #(v1 bizProcessServiceData)
			ASSIGNVAL #(bizProcess aspectStatus))}.
		{#behavior:reuse:modify: . #'From Offer' . #'From Request' . #(
			READSLOT #(bizOfferServiceData v1) ) }.
		{#behavior:reuse:modify: . #'From Order' . #'From Request' . #(
			READSLOT #(bizOrderServiceData v1) ) }.
 	}  ! !

!GCContexts class methodsFor: 'process contexts' stamp: 'hk 1/27/2018 17:01'!
gcBizProcessesContext  

	^GbtPrimeListSC struct: 'GCBizProcessesContext' define: {
		{#displayAs: . 'Biz Processes'  }.
		{#noPolicyPrefix: . 'BizP'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #bizProcesses}.
		{#templates: . GCBizProcess bizProcess }.
		{#display: . #( #(majorServiceType processType) firstName lastName company #(bizProcessOwnership owner) #(gcDate created)) }.
		{#subcontext: . GCContexts gcBizProcessContext  }.
		
		{#onReceiveDo: . #(pushRequest pushConfirmOffer pushOrder) }.
		{#behavior:actions: . #pushRequest . #(
			GETEVENT GCBizNetRequest 
			MATCH #(thing bizProcessBizId) 
			EMBED #(thing GCBizNetConfirmRequest) 
			CONTEXT GCRequestContext 
			ASSUREVO void
			CONSTRAINTS #(processId customer aspectProcessBizId))}.
		{#behavior:reuse:modify: . #pushConfirmOffer . #pushRequest . #(
			GETEVENT GCBizNetConfirmOffer 
			EMBED #(thing GCBizNetOffer )
			CONTEXT GCOfferContext )}.
		{#behavior:reuse:modify: . #pushOrder . #pushRequest . #(
			GETEVENT GCBizNetOrder 
			EMBED #(thing GCBizNetConfirmOrder )
			CONTEXT GCOrderContext )}.
	}	! !

!GCContexts class methodsFor: 'main context' stamp: 'hk 1/27/2018 17:01'!
gcCalcContext  
	^GbtPrimeListSC struct: 'GCCalcContext' define: {
		{#displayAs: . 'Calculator'  } .
		{#uiSpec:icon:  . #GcCalcUI . #userSettings}} ! !

!GCContexts class methodsFor: 'contact contexts' stamp: 'hk 1/27/2018 17:01'!
gcContactContext  
	^GbtPlainSC struct: 'GCContactContext' define: {
		{#displayAs: . 'Contact'  } .
		{#uiSpec:icon: . #GbtItemUI . #contacts} .
		
		{#menu: . #email }.
		{#behavior:actions: . #email . #(READSLOT #(eMail v1) CONTEXT GCEmailContext WRITESLOT #(v1 emailAddr) EDIT contextVO)}.
	}! !

!GCContexts class methodsFor: 'contact contexts' stamp: 'hk 1/27/2018 17:01'!
gcContactsContext  
	^GbtPrimeListSC struct: 'GCContactsContext' define: {
		{#displayAs: . 'Contacts'  } .
		{#noPolicyPrefix: . 'Cont'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #contacts} .
		{#templates: . GCContact contact } .
		{#display: . #(firstName lastName company) } .
		{#subcontext: . self gcContactContext  } .

		{#onReceiveDo: . #(attach) }.
		{#behavior:actions: . #attach . #(GETEVENT GCContact TOLIST thing)}.
	}! !

!GCContexts class methodsFor: 'process contexts' stamp: 'hk 1/27/2018 17:01'!
gcCustomerContext  
	^GbtPlainSC struct: 'GCCustomerContext'  define:  {
		{#displayAs: . 'Customer' } .
		{#uiSpec:icon: . #GbtAspectUI . #contacts} .
		{#chooseWith: . GCContexts gcContactsContext } .
		{ #voChange: . #addOnly }.
	}	
! !

!GCContexts class methodsFor: 'main context' stamp: 'hk 1/27/2018 17:01'!
gcDashContext  
	^GbtPrimeListSC struct: 'GCDashContext' define: {  
		{#displayAs: . 'Dash Board'  } .
		{#uiSpec:icon: . #GcDashUI . #dash} 
	}! !

!GCContexts class methodsFor: 'main context' stamp: 'hk 1/27/2018 17:01'!
gcEmailContext  
	^GbtPlainSC struct: 'GCEmailContext'  define: {
		{#displayAs: . 'Email'  } .
		{#uiSpec:icon: . #GbtItemUI . #email} .
		{#vo: . GbtApplicationTest eMail } .
	}! !

!GCContexts class methodsFor: 'main context' stamp: 'hk 1/27/2018 17:01'!
gcLoginContext
	^ GbtPlainSC struct: 'GCLogin' define:
			{{#uiSpec:icon: . #GbtLoginUI . #header}.
			{#displayAs: . #'Inside Transport'}.
			{#aspect:on: . self gcMainContext . nil }.
			{#legalText: . 'GloConn International © 2018'}}! !

!GCContexts class methodsFor: 'main context' stamp: 'hk 1/27/2018 17:01'!
gcMainContext
	^ GbtPlainSC struct: 'GCMainContext' define:
			{{#aspect:on:. GCContexts gcContactsContext. nil}.
			{#aspect:on:. GCContexts gcBizProcessesContext. nil}.
			{#aspect:on:. GCContexts gcTaskOrdersContext. nil}.
			{#aspect:on:. GCContexts gcSupplierBizProcessesContext. nil}.
			{#aspect:on:. GCContexts gcDashContext. nil}.
			{#aspect:on:. GCContexts gcCalcContext. nil}.
			{#uiSpec:icon: . #GbtGloConnMainUI . #header}.
			{#displayAs: . 'Inside Transport'}.
			{#legalText: . 'GloConn International © 2018'}.
			{#onReceiveDo:. #(#pushCust #pushOffer #pushRequest #pushOrder #pushConfirmRequest #pushConfirmOffer #pushConfirmOrder)}.
			{#behavior:actions:. #pushCust. #(#GETEVENT #GCContact #PUSHTO #GCContactsContext)}.
			{#behavior:actions:. #pushRequest. #(#GETEVENT #GCBizNetRequest #PUSHTO #GCBizProcessesContext)}.
			{#behavior:actions:. #pushConfirmOffer. #(#GETEVENT #GCBizNetConfirmOffer #PUSHTO #GCBizProcessesContext)}.
			{#behavior:actions:. #pushOrder. #(#GETEVENT #GCBizNetOrder #PUSHTO #GCBizProcessesContext)}.
			{#behavior:actions:. #pushConfirmRequest. #(#GETEVENT #GCBizNetConfirmRequest #PUSHTO #GCSupplierBizProcessesContext)}.
			{#behavior:actions:. #pushOffer. #(#GETEVENT #GCBizNetOffer #PUSHTO #GCSupplierBizProcessesContext)}.
			{#behavior:actions:. #pushConfirmOrder. #(#GETEVENT #GCBizNetConfirmOrder #PUSHTO #GCSupplierBizProcessesContext)}}! !

!GCContexts class methodsFor: 'process contexts' stamp: 'hk 1/27/2018 17:01'!
gcOfferContext  
	^GbtPlainSC struct: 'GCOfferContext' define: { 
		{#displayAs: . 'Offer' } .
		{#noPolicyPrefix: . 'OF'}.
		{#uiSpec:icon: . #GbtAspectUI . #bizoffer16}.
		{#voChange: . #addyRemove }.
		{#templates: . {GCBizProcess  bizOffer . IntegrationTestThings bizOffer1} } .
		{#blackboardSlot: . #bizOfferServiceData }.

		{#createBehaviors: . #( serviceData serviceDataAspect) }.
		{#behavior:actions: . #serviceData . #(
			CONTEXT GCBizProcessContext 
			READSLOT #(bizProcessServiceData v1)
			CONTEXT GCOfferContext 
			WRITESLOT #(v1 bizOfferServiceData))}.
		{#behavior:actions: . #serviceDataAspect . #(
			READSLOT #(bizOfferServiceData thing)
			ASSIGNVAL #(offer aspectStatus) )}.

 		{#constraints: . #( aspectProcessBizId processId customer supplier ) } .
		{#constraint:left:right: . #processId . #(CONTEXT GCBizProcessContext SLOT bizId ) . #(SLOT bizProcessBizId)}.
		{#constraint:left:right: . #customer . #(CONTEXT GCBizProcessContext SLOT bizCustomer ) . #(SLOT bizOfferCustomer)}.
		{#constraint:left:right: . #supplier . #(CONTEXT GCMainContext SLOT activeServiceAgent) . #(SLOT bizOfferSupplier)}.
		{#constraint:left:right: . #aspectProcessBizId . #(CONTEXT GCBizProcessContext SLOT aspectProcessBizId) . #(SLOT aspectProcessBizId)}.
	}
! !

!GCContexts class methodsFor: 'process contexts' stamp: 'hk 1/27/2018 17:01'!
gcOrderContext  
	^GbtPlainSC struct: 'GCOrderContext' define: { 
		{#displayAs: . 'Order'} .
		{#noPolicyPrefix: . 'ORD'}.
		{#uiSpec:icon: . #GbtAspectUI . #bizorder16}.
		{#templates: . {GCBizProcess  bizOrder} }.
		{#voChange: . #addyRemove }.
		{#blackboardSlot: . #bizOrderServiceData }.

		{#createBehaviors: . #( serviceData serviceDataAspect) }.
		{#behavior:actions: . #serviceData . #(
			CONTEXT GCBizProcessContext 
			READSLOT #(bizProcessServiceData v1)
			CONTEXT GCOrderContext 
			WRITESLOT #(v1 bizOrderServiceData))}.
		{#behavior:actions: . #serviceDataAspect . #(
			READSLOT #(bizOrderServiceData thing)  
			ASSIGNVAL #(order aspectStatus))}.
		
		{#constraints: . #(aspectProcessBizId processId customer supplier ) } .
		{#constraint:left:right: . #processId . #(CONTEXT GCBizProcessContext SLOT bizId ) . #(SLOT bizProcessBizId)}.
		{#constraint:left:right: . #customer . #(CONTEXT GCBizProcessContext SLOT bizCustomer ) . #(SLOT bizOrderCustomer)}.
		{#constraint:left:right: . #supplier . #(CONTEXT GCMainContext SLOT activeServiceAgent) . #(SLOT bizOrderSupplier)}.
		{#constraint:left:right: . #aspectProcessBizId . 	#(CONTEXT GCBizProcessContext SLOT aspectProcessBizId) . #(SLOT aspectBizId)}.
	}
	
! !

!GCContexts class methodsFor: 'process contexts' stamp: 'hk 1/27/2018 17:01'!
gcRequestContext  
	^GbtPlainSC struct: 'GCRequestContext' define: {
		{#displayAs:  .'Request' } .
		{#uiSpec:icon: . #GbtAspectUI . #bizrequest16}.
		{#voChange: . #addyRemove }.
		{#templates: . GCBizProcess bizRequest } .
		{#blackboardSlot: . #bizRequestServiceData }.
				
		{#createBehaviors: . #( serviceData serviceDataAspect) }.
		{#behavior:actions: . #serviceData . #(
			CONTEXT GCBizProcessContext 
			READSLOT #(bizProcessServiceData v1)
			CONTEXT GCRequestContext 
			WRITESLOT #(v1 bizRequestServiceData))}.
		{#behavior:actions: . #serviceDataAspect . #(
			READSLOT #(bizRequestServiceData thing)  
			ASSIGNVAL #(request aspectStatus))}.
			
		{#constraints: . #( processId customer supplier aspectProcessBizId) } .
		{#constraint:left:right: . #processId . #(CONTEXT GCBizProcessContext SLOT bizId) . #(SLOT bizProcessBizId)}.
		{#constraint:left:right: . #customer . #(CONTEXT GCBizProcessContext SLOT bizCustomer ) . #(SLOT bizRequestCustomer)}.
		{#constraint:left:right: . #supplier . #(CONTEXT GCMainContext SLOT activeServiceAgent) . #(SLOT bizRequestSupplier)}.
		{#constraint:left:right: . #aspectProcessBizId . #(CONTEXT GCBizProcessContext SLOT aspectProcessBizId) . #(SLOT aspectProcessBizId)}.
 	} ! !

!GCContexts class methodsFor: 'process contexts' stamp: 'hk 1/27/2018 17:01'!
gcServiceDataContext  
	| template |
	template := GCServiceData  serviceData .
	template serviceDataItems newEntry: IntegrationTestThings serviceDataItemTransport_BtoHB_2Items.
	
	^GbtPlainSC struct: 'GCServiceDataContext' define: { 
		{#displayAs: . 'Service Data'  }.
		{#noPolicyPrefix: . 'SD'}.
		{#uiSpec:icon: . #GbtAspectUI . #servicedata16}.
		{ #voChange: . #addyRemove }.
		{#templates: . {template . GCServiceData  serviceData} } .
	}! !

!GCContexts class methodsFor: 'supplierContexts' stamp: 'hk 1/27/2018 17:01'!
gcSupplierBizProcessContext  
	^GbtPlainSC struct: 'GCSupplierBizProcessContext' define: {
		{#displayAs: . 'Supplier BizProcess'  } .
		{#display: . #(supplierBizProcessType supplierBizProcessOwnership supplierBizProcessStatus ) }.
		{#uiSpec:icon: . #GbtItemWithTabsUI . #supplierBizProcesses} .
		{#aspect:on: . self gcSuppliersServiceDataContext . #supplierServiceData } .
		{#aspect:on: . self gcSupplierBizSubProcessesContext . #supplierBizSubProcesses } 
	}! !

!GCContexts class methodsFor: 'supplierContexts' stamp: 'hk 1/27/2018 17:01'!
gcSupplierBizProcessesContext  
	^GbtPrimeListSC struct: 'GCSupplierBizProcessesContext'  define: { 
		{#displayAs: . 'Supplier BizProcesses'  } .
		{#display: . #( #(majorServiceType processType) #(issueDate created) supplierBizProcessStatus ) }.
		{#noPolicyPrefix: . 'SupP'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #supplierBizProcesses} . 
		{#templates: . GCSupplierBizProcess supplierBizProcess } .
		{#subcontext: . GCContexts gcSupplierBizProcessContext } .

		{#onReceiveDo: . #(pushConfirmRequest pushOffer pushConfirmOrder) }.
		{#behavior:actions: . #pushConfirmRequest . #(
			GETEVENT GCBizNetConfirmRequest 
			MATCH #(thing supplierProcessBizId) 
			PUSHTO GCSupplierBizSubProcessesContext)}.
		{#behavior:reuse:modify: . #pushOffer . #pushConfirmRequest . #(GETEVENT GCBizNetOffer )}.	
		{#behavior:reuse:modify: . #pushConfirmOrder . #pushConfirmRequest . #(GETEVENT GCBizNetConfirmOrder)}.	
	}
	
 ! !

!GCContexts class methodsFor: 'supplierContexts' stamp: 'hk 1/27/2018 17:01'!
gcSupplierBizSubProcessContext  
	^GbtPlainSC struct: 'GCSupplierBizSubProcessContext' define: { 
		{#displayAs: . 'Supplier BizSubprocess' }.
		{#display: . #( supplierBizProcessId gcDate company firstName lastName bizProcessOwner) }.
		{#uiSpec:icon: . #GbtItemWithTabsUI . #supplierBizSubProcesses}.		
		{#blackboardAspect:on: . self gcSupplierServiceDataContext .  #supplierSubProcessServiceData } .
		{#aspect:on: . self gcSupplierContactContext . #bizSupplier }.
		{#aspect:on: . self gcSupplierRequestContext . #supplierBizRequest }.
		{#aspect:on: . self gcSupplierOfferContext . #supplierBizOffer }.
		{#aspect:on: . self gcSupplierOrderContext . #supplierBizOrder } .

		{#createBehaviors: . #( serviceData processBizId agent) }.
		{#behavior:actions: . #serviceData . #(
			CONTEXT GCSupplierBizProcessContext
			READSLOT #(supplierServiceData v1) 
			CONTEXT GCSupplierBizSubProcessContext 
			WRITESLOT #(v1 supplierSubProcessServiceData))}.		
		{#behavior:reuse:modify:  . #processBizId . #serviceData . #(
			READSLOT #(bizId v1)
			WRITESLOT #(v1 supplierBizProcessId))}.		
		{#behavior:reuse:modify: . #agent . #serviceData . #(
			CONTEXT GCMainContext 
			READSLOT #(activeServiceAgent v1)
			WRITESLOT #(v1 bizCustomer))}.		
		
		{#menu:items: . #BizNet . #(SendRequest ConfirmOffer SendOrder) }.
		{#menu:items: . #ServiceData . #(FromRequest FromOffer FromOrder) }.
		
		{#behavior:actions: . #SendRequest . #(COMPOSE GCBizNetRequest SENDTO #(bizSupplier company))}.
		{#behavior:actions: . #ConfirmOffer . #(COMPOSE GCBizNetConfirmOffer SENDTO #(bizSupplier company))}.
		{#behavior:actions: . #SendOrder . #(COMPOSE GCBizNetOrder SENDTO #(bizSupplier company))}.
		
		{#behavior:actions: . #FromRequest . #(
			READSLOT #(#(supplierBizRequest bizRequestServiceData) v1)
			WRITESLOT #(v1 supplierSubProcessServiceData) 
			ASSIGNVAL #(bizProcess aspectStatus))}.
		{#behavior:reuse:modify: . #FromOffer . #FromRequest . #(READSLOT #(supplierBizOffer bizOfferServiceData v1) )}.
		{#behavior:reuse:modify: . #FromOrder . #FromRequest . #(READSLOT #(supplierBizOrder bizOrderServiceData v1) )}.

	}
! !

!GCContexts class methodsFor: 'supplierContexts' stamp: 'hk 1/27/2018 17:00'!
gcSupplierBizSubProcessesContext  
	^GbtNodeListSC struct: 'GCSupplierBizSubProcessesContext'  define: { 
		{#displayAs: . 'Supplier BizSubprocesses' }.
		{#display: . #( supplierBizProcessId gcDate company firstName lastName bizProcessOwner) }.
		{#noPolicyGetter: . #alphaCapID}.
		{#uiSpec:icon: . #GbtListAndItemUI . #supplierBizSubProcesses}.
		{#template:for: . GCSupplierBizProcess supplierBizSubProcess . #supplierBizSubProcesses}.			
		{#chooseFor: . #bizSupplier }.
		{#chooseWith: . self gcContactsContext }.
		{#subcontext: . self gcSupplierBizSubProcessContext }.

		{#onReceiveDo: . #(pushConfirmRequest pushOffer pushConfirmOrder) }.
		{#behavior:actions: . #pushConfirmRequest . #(
			GETEVENT GCBizNetConfirmRequest 
			MATCH #(thing supplierSubProcessBizId) 
			EMBED #(thing GCBizNetRequest)
			CONTEXT GCSupplierRequestContext 
			ASSUREVO void
			BEHAVIORS #(bizProcessBizId)
			CONSTRAINTS #(supplier "supplierBizId customerBizId" supplierBizProcessId supplierSubProcessId ) )}.
		{#behavior:reuse:modify: . #pushOffer . #pushConfirmRequest . #(
			GETEVENT GCBizNetOffer 
			EMBED #(thing GCBizNetConfirmOffer)
			CONTEXT GCSupplierOfferContext)}.	
		{#behavior:reuse:modify: . #pushConfirmOrder . #pushConfirmRequest . #(
			GETEVENT GCBizNetConfirmOrder 
			EMBED #(thing GCBizNetOrder)
			CONTEXT GCSupplierOrderContext )}.	
	}! !

!GCContexts class methodsFor: 'supplierContexts' stamp: 'hk 1/27/2018 17:01'!
gcSupplierContactContext  
	^GbtPlainSC struct: 'GCSupplierContactContext' define: { 
		{#displayAs: . 'Supplier' }.
		{#uiSpec:icon: . #GbtAspectUI . #contacts}.
					
		{#constraints: . #(supplierBizId) } .
		{#constraint:left:right: . #supplierBizId . #(SLOT bizId) . #(CONTEXT GCSupplierBizSubProcessContext SLOT supplierBizId)} }! !

!GCContexts class methodsFor: 'supplierContexts' stamp: 'hk 1/27/2018 17:01'!
gcSupplierOfferContext  
	^GbtPlainSC struct: 'GCSupplierOfferContext' define: {
		{#displayAs: . 'Supplier Offer'  }.
		{#uiSpec:icon: . #GbtAspectUI . #bizoffer16}.
		{ #voChange: . #addyRemove }.
		{#templates: . {GCBizProcess  bizOffer . IntegrationTestThings bizOffer1} }. 	
		{#blackboardSlot: . #bizOfferServiceData }.

		{#createBehaviors: . #( serviceDataR processConstraints serviceDataAspect) }.	
		{#behavior:actions: . #serviceDataR . #(
			CONTEXT GCSupplierBizSubProcessContext 
			READSLOT #(supplierSubProcessServiceData v1)
			CONTEXT GCSupplierOfferContext 
			WRITESLOT #(v1 bizOfferServiceData))}.		
		{#behavior:actions: . #processConstraints . #(CONSTRAINTS #(supplier supplierBizProcessId supplierSubProcessId) )}.
		{#behavior:actions: . #serviceDataAspect . #(READSLOT #(bizOfferServiceData thing)  ASSIGNVAL #(offer aspectStatus))}.

		{#behavior:actions: . #bizProcessBizId . #(
			READSLOT #(bizProcessBizId v1)
			CONTEXT GCSupplierBizSubProcessContext 
			WRITESLOT #(v1 bizProcessBizId))}.

		{#constraints: . #( customer offerSD supplierBizId customerBizId aspectProcessBizId) } .
		{#constraint:left:right: . #customer . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizCustomer ) . #(SLOT bizOfferCustomer )}.
		{#constraint:left:right: . #offerSD . #(CONTEXT GCSupplierBizSubProcessContext SLOT subProcessServiceData ) . #(SLOT bizOfferServiceData )}.	
		{#constraint:left:right: . #supplierBizId . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizId) . #(SLOT supplierBizId)}.
		{#constraint:left:right: . #customerBizId . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizId) . #(SLOT customerBizId)}.

		{#constraint:left:right: . #supplier . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizSupplier ) . #(SLOT bizOfferSupplier)}.
		{#constraint:left:right: . #supplierBizProcessId . #(CONTEXT GCSupplierBizSubProcessContext SLOT supplierBizProcessId) . #(SLOT supplierProcessBizId)}.
		{#constraint:left:right: . #supplierSubProcessId . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizId) . #(SLOT supplierSubProcessBizId)}.

		{#constraint:left:right: . #aspectProcessBizId . #(CONTEXT GCSupplierBizSubProcessContext SLOT aspectProcessBizId) . #(SLOT aspectProcessBizId)}.
	}
			
		
	


! !

!GCContexts class methodsFor: 'supplierContexts' stamp: 'hk 1/27/2018 17:01'!
gcSupplierOrderAckContext  
	^GbtPlainSC struct: 'GCSupplierOrderAckContext' define: { 
		{#displayAs: . 'Supplier Order Acknowledge' }
	}! !

!GCContexts class methodsFor: 'supplierContexts' stamp: 'hk 1/27/2018 17:01'!
gcSupplierOrderContext  
	^GbtPlainSC struct: 'GCSupplierOrderContext' define: { 
		{#displayAs: . 'Supplier Order' }.
		{#uiSpec:icon: . #GbtAspectUI . #bizorder16}.
		{ #voChange: . #addyRemove }.
		{#templates: . {GCBizProcess  bizOrder } }.
		{#blackboardSlot: . #bizOrderServiceData }.

		{#createBehaviors: . #( serviceDataR processConstraints serviceDataAspect) }.	
		{#behavior:actions: . #serviceDataR . #(
			CONTEXT GCSupplierBizSubProcessContext 
			READSLOT #(supplierSubProcessServiceData v1)
			CONTEXT GCSupplierOrderContext 
			WRITESLOT #(v1 bizOrderServiceData))}.		
 		{#behavior:actions: . #processConstraints . #(CONSTRAINTS #(supplier supplierBizProcessId supplierSubProcessId) )}.
		{#behavior:actions: . #serviceDataAspect . #(READSLOT #(bizOrderServiceData thing)  ASSIGNVAL #(order aspectStatus))}.

		{#behavior:actions: . #bizProcessBizId . #(READSLOT #(bizProcessBizId v1) CONTEXT GCSupplierBizSubProcessContext WRITESLOT #(v1 bizProcessBizId))}.

		{#constraints: . #( customer orderSD supplierBizId customerBizId aspectProcessBizId) } .
		{#constraint:left:right: . #customer . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizCustomer) . #(SLOT bizOrderCustomer)}.
		{#constraint:left:right: . #orderSD . #(CONTEXT GCSupplierBizSubProcessContext SLOT subProcessServiceData) . #(SLOT bizOrderServiceData)}.	
		{#constraint:left:right: . #supplierBizId . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizId) . #(SLOT supplierBizId)}.
		{#constraint:left:right: . #customerBizId . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizId) . #(SLOT customerBizId)}.

		{#constraint:left:right: . #supplier . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizSupplier) . #(SLOT bizOrderSupplier)}.
		{#constraint:left:right: . #supplierBizProcessId . #(CONTEXT GCSupplierBizSubProcessContext SLOT supplierBizProcessId) . #(SLOT supplierProcessBizId)}.
		{#constraint:left:right: . #supplierSubProcessId . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizId) . #(SLOT supplierSubProcessBizId)}.

		{#constraint:left:right: . #aspectProcessBizId . #(CONTEXT GCSupplierBizSubProcessContext SLOT aspectProcessBizId) . #(SLOT aspectProcessBizId)}.
	}	 ! !

!GCContexts class methodsFor: 'supplierContexts' stamp: 'hk 1/27/2018 17:01'!
gcSupplierRequestContext  
	^GbtPlainSC struct: 'GCSupplierRequestContext' define: {
		{#displayAs: . 'Supplier Request' } .
		{#uiSpec:icon: . #GbtAspectUI . #bizrequest16}.
		{#voChange: . #addyRemove }.
		{#templates: . GCBizProcess bizRequest } .
		{#blackboardSlot: . #bizRequestServiceData }.

		{#createBehaviors: . #(serviceDataR processConstraints serviceDataAspect) }.
		{#behavior:actions: . #serviceDataR . #(
			CONTEXT GCSupplierBizSubProcessContext 
			READSLOT #(supplierSubProcessServiceData v1)
			CONTEXT GCSupplierRequestContext 
			WRITESLOT #(v1 bizRequestServiceData))}.
		{#behavior:actions: . #processConstraints . #(CONSTRAINTS #(supplier supplierBizProcessId supplierSubProcessId) )}.
		{#behavior:actions: . #serviceDataAspect . #(READSLOT #(bizRequestServiceData thing)  ASSIGNVAL #(request aspectStatus))}.

		{#behavior:actions: . #bizProcessBizId . #(READSLOT #(bizProcessBizId v1) CONTEXT GCSupplierBizSubProcessContext WRITESLOT #(v1 bizProcessBizId))}.
		
		{#constraints: . #( customer requestSD supplierBizId customerBizId aspectProcessBizId) } .
		{#constraint:left:right: . #customer . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizCustomer ) . #(SLOT bizRequestCustomer )}.
		{#constraint:left:right: . #requestSD . #(CONTEXT GCSupplierBizSubProcessContext SLOT subProcessServiceData ) . #(SLOT bizRequestServiceData )}.	
		{#constraint:left:right: . #supplierBizId . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizId) . #(SLOT supplierBizId)}.
		{#constraint:left:right: . #customerBizId . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizId) . #(SLOT customerBizId)}.

		{#constraint:left:right: . #supplier . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizSupplier ) . #(SLOT bizRequestSupplier)}.
		{#constraint:left:right: . #supplierBizProcessId . #(CONTEXT GCSupplierBizSubProcessContext SLOT supplierBizProcessId) . #(SLOT supplierProcessBizId)}.
		{#constraint:left:right: . #supplierSubProcessId . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizId) . #(SLOT supplierSubProcessBizId)}.
		{#constraint:left:right: . #aspectProcessBizId . #(CONTEXT GCSupplierBizSubProcessContext SLOT aspectProcessBizId) . #(SLOT aspectProcessBizId)}.
	}  ! !

!GCContexts class methodsFor: 'supplierContexts' stamp: 'hk 1/27/2018 17:01'!
gcSupplierServiceDataContext  
	| template |
	template := GCServiceData  serviceData. 
	template serviceDataItems newEntry: IntegrationTestThings serviceDataItemTransport_BtoHB_2Items.
	
	^GbtPlainSC struct: 'GCSupplierServiceDataContext'  define: { 
		{#displayAs: . 'Service Data'  }.
		{#uiSpec:icon: . #GbtAspectUI . #servicedata16}.
		{ #voChange: . #addyRemove }.
		{#templates: . {GCServiceData  serviceData . template} } .	}! !

!GCContexts class methodsFor: 'supplierContexts' stamp: 'hk 1/27/2018 17:01'!
gcSuppliersServiceDataContext  
	| template |
	template := GCServiceData  serviceData.
	template serviceDataItems newEntry: IntegrationTestThings serviceDataItemTransport_BtoHB_2Items.

	^GbtPlainSC struct: 'GCSuppliersServiceDataContext' define: { 
		{#displayAs: . 'Service Data'  }.
		{#uiSpec:icon: . #GbtAspectUI . #servicedata16}.
		{ #voChange: . #addyRemove }.
		{#templates: . {template . GCServiceData  serviceData} } .
	}! !

!GCContexts class methodsFor: 'task orders' stamp: 'hk 1/27/2018 17:01'!
gcTaskOrderContext  
	^GbtPlainSC struct: 'GCTaskOrderContext' define: {
		{#displayAs: . 'Task Order'  } .
		{#uiSpec:icon: . #GbtItemUI . #taskOrder} 
	}! !

!GCContexts class methodsFor: 'task orders' stamp: 'hk 1/27/2018 17:01'!
gcTaskOrdersContext  
	^GbtPrimeListSC struct: 'GCTaskOrdersContext' define: {
		{#displayAs: . 'Task Orders'  } .
		{#noPolicyPrefix: . 'TO'}.
		{#uiSpec:icon: . #GbtListUI . #taskOrders} . 
		{#templates: . GCTaskOrder taskOrder } .
		{#subcontext: . self gcTaskOrderContext } 
	}! !

Object subclass: #GCDirectives
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Program'!

!GCDirectives class methodsFor: 'request offer-order' stamp: 'hk 1/27/2018 16:28'!
bizNetConfirmOfferCombinator
	"self bizNetOfferCombinator edit
	bizNet names     ---      local names"
	
	^GbtSmartProjector struct: 'GCBizNetConfirmOffer' define: { 
		{ #offer . #tag: . #supplierBizOffer  }.
	 }
! !

!GCDirectives class methodsFor: 'request offer-order' stamp: 'hk 1/27/2018 16:28'!
bizNetConfirmOrderCombinator
	"self bizNetGetOrderCombinator edit
	bizNet names     ---      local names"
	
	^GbtSmartProjector struct: 'GCBizNetConfirmOrder' define: { 
		{ #order . #tag: . #bizOrder  }.
	 }! !

!GCDirectives class methodsFor: 'request offer-order' stamp: 'hk 1/27/2018 16:28'!
bizNetConfirmRequestCombinator
	"self bizNetConfirmRequestCombinator edit
	bizNet names     ---      local names"
	
	^GbtSmartProjector struct: 'GCBizNetConfirmRequest' define: { 
		{ #request . #tag: . #bizRequest  }.
	 }
! !

!GCDirectives class methodsFor: 'request offer-order' stamp: 'hk 1/27/2018 16:28'!
bizNetOfferCombinator
	"self bizNetGetOfferCombinator edit
	bizNet names     ---      local names"
	
	^GbtSmartProjector struct: 'GCBizNetOffer' define: { 
		{ #offer . #tag: . #bizOffer  }.
	 }! !

!GCDirectives class methodsFor: 'request offer-order' stamp: 'hk 1/27/2018 16:28'!
bizNetOrderCombinator
	"self bizNetOrderCombinator edit
	bizNet names     ---      local names"
	
	^GbtSmartProjector struct: 'GCBizNetOrder' define: { 
		{ #order . #tag: . #supplierBizOrder  }.
	 }
! !

!GCDirectives class methodsFor: 'request offer-order' stamp: 'hk 1/27/2018 16:28'!
bizNetRequestCombinator
	"self bizNetRequestView edit
	bizNet names     ---      local names"
	
	^GbtSmartProjector struct: 'GCBizNetRequest' define: { 
		{ #request . #tag: . #supplierBizRequest  }.
	 }! !

!GCDirectives class methodsFor: 'service data' stamp: 'hk 1/27/2018 16:28'!
bizNetSupplierServiceDataCombinator
	"self bizNetSupplierServiceDataCombinator edit"
	
	^GbtSmartProjector struct: 'GCBizNetServiceData' define: { 
		{ #bizRequestServiceData  . #tag: . #supplierServiceData  }.
	 }! !

!GCDirectives class methodsFor: 'initialize' stamp: 'hk 9/24/2017 15:43'!
initializeInterfaceCombinators
	GCDirectives 
		bizNetRequestCombinator; 
		bizNetConfirmRequestCombinator ;
		bizNetSupplierServiceDataCombinator;
		bizNetOfferCombinator;
		bizNetConfirmOfferCombinator;
		bizNetOrderCombinator;
		bizNetConfirmOrderCombinator! !
